/*
	 Colonization save game editor
	 -----------------------------

    The program below is a "C" language "cheat program" for the
    Colonization game by Microprose.

    It basically reads through the cities and boosts raw materials.
    A crude hack at best, but then again, that's how great nations
    begin.

    The code is given here because the file layout changes
    from version to version, and because there is really nothing
    proprietary about it.

    Basically, using this program spoils the game because it
    makes for a sure win every time.  I used it a couple of
    times to try different strategies, but I don't need it
    anymore.

    NOTE:  This program is known to work for the GERMAN language
    version of the product only!!!!!  If you have another language
    version of this game, you have to check things out carefully
    before proceeding.  I play the GERMAN versions of games because
    it keeps me on my toes (otherwise I wouldn't get to know
    what an "Eisenhuette" is).

    HACKER'S NOTE:  The array of cities begins at byte 392 and
    extend to the number of cities established so far in the game.
    The length of a city is 202 bytes.  The materials available
    to a city are an array of unsigned integers (but with Microprose
    who really knows?) beginning at offset 152.

*/
#include        <stdio.h>
#include       <stdlib.h>
#include       <string.h>
#include           <io.h>
#include        <fcntl.h>
#include     <sys/stat.h>
#include        <ctype.h>
#include        <conio.h>

/* these are the materials for the game */
/* What?? You don't understand German?? */
char *Materials[] = {
    "Nahrungsmittel",
    "Zucker",
    "Tabak",
    "Baumwolle",
    "Felle",
    "Nutzholz",
    "Erz",
    "Silber",
    "Pferde",
    "Rum",
    "Zigarren",
    "Stoff",
    "Maentel",
    "Handelswaren",
    "Werkzeuge",
    "Musketen",
    NULL};
/* how much of each material should be replenished */
unsigned char Replenishment[] = { 255, 100, 100, 100, 
                         100, 100, 300, 100, 
                         255, 100, 100, 100, 
                         100, 100, 255, 255 };
int hSaveFile;
int ReadResult;
int WriteResult;
long Floc;
#define  Reclength  202
unsigned char CityBuffer[ Reclength ];
int main( int argc, char *argv[] )
{
     int i;
     int offset;
     int changed;
     printf( "MYCOL:  a colonization editor\n" );
     if( argc < 2 ) {
         printf( "File name required\n" );
         return( 0 );
     }
     hSaveFile = open( argv[ 1 ], O_RDWR | O_BINARY );
     if( hSaveFile > 0 ) {
         Floc = 392;
         lseek( hSaveFile, Floc, SEEK_SET );
         ReadResult = read( hSaveFile, CityBuffer, Reclength );
         while( isalpha( CityBuffer[ 0 ] ) ) {
                changed = 0;
                printf( "Boost resources for %s?", CityBuffer );
                printf( "\n" );
                switch( toupper( getch() ) ) {
                        case 'J':  /* german */
                        case 'Y':
                             offset = 152;
                             changed = 0;
                             for( i = 0; i < 16; i++ ) {
                                  if( CityBuffer[ offset ] < Replenishment[ i ] ) {
                                      ++changed;
                                      CityBuffer[ offset ] = Replenishment[ i ];
                                      printf( "\t\tBoosting %s\n", Materials[ i ] );
                                  }
                                  offset += 2; /* just the low order byte */
                             }
                             if( changed ) {
                                 printf( "\t\t\t\tUpdating %s\n", CityBuffer );
                                 lseek( hSaveFile, Floc, SEEK_SET );
                                 WriteResult = write( hSaveFile, CityBuffer, Reclength );
                             } else {
                                 printf( "%s not changed\n", CityBuffer );
                             }
                }
                Floc = tell( hSaveFile );
                ReadResult = read( hSaveFile, CityBuffer, Reclength );
         }
         close( hSaveFile );
     } else {
         printf( "Cannot find %s\n", argv[ 1 ] );
     }
     return( 0 );
}

