/*
	 MASTERS OF ORION EDITOR
	 -----------------------

    The program below is a "C" language "cheat program" for the
    Masters of Orion game by Microprose.

    Basically it reads through the planets and fixes things up
    for really knock 'em dead game.

    I have used it to test out ship designs, various strategies,
    and what-not.

    The code is given here because the file layout changes
    from version to version, and because there is really nothing
    proprietary about it.

*/
#include        <stdio.h>
#include       <stdlib.h>
#include       <string.h>
#include           <io.h>
#include        <fcntl.h>
#include     <sys/stat.h>
#include        <ctype.h>
char *Planet_types[] = {
    "none",
    "radiated",
    "toxic",
    "inferno",
    "dead",
    "tundra",
    "barren",
    "minimal",
    "desert",
    "steppe",
    "arid",
    "ocean",
    "jungle",
    "terran",
    NULL };
char *Planet_fertility[] = {
        "hostile",
        "friendly",
        "fertile",
        "gaia",
        NULL };
char *Planet_quality[] = {
      "ultra poor",
      "poor",
      "normal",
      "artifacts",
      "rich",
      "ultra rich",
      "orion",
      NULL };
int hSaveFile;
char PlanetBuffer[ 184 ];
int ReadResult;
int WriteResult;
long Floc;
int main( int argc, char *argv[] )
{
     int population;
     int maxpopulation;
     int changed;
     unsigned long resources;
     printf( "MYMOO:  a moo editor\n" );
     if( argc < 2 ) {
         printf( "File name required\n" );
         return( 0 );
     }
     hSaveFile = open( argv[ 1 ], O_RDWR | O_BINARY );
     if( hSaveFile > 0 ) {
         Floc = 0;
         ReadResult = read( hSaveFile, PlanetBuffer, 184 );
         while( isalpha( PlanetBuffer[ 0 ] ) ) {
                changed = 0;
                printf( "%s (%s/%s/%s)\n", PlanetBuffer,
                                           Planet_types[ PlanetBuffer[ 32 ] ],
                                           Planet_fertility[ PlanetBuffer[ 38 ] ],
                                           Planet_quality[ PlanetBuffer[ 40 ] ]
                                                    );
                if( !PlanetBuffer[ 54 ] ) {
                    printf( "\tSettled by player\n" );
                    memmove( &population, &PlanetBuffer[ 58 ], sizeof( int ) );
                    memmove( &maxpopulation, &PlanetBuffer[ 30 ], sizeof (int ) );
                    if( population < ( maxpopulation - 1 ) ) {
                        population = maxpopulation - 1;
                        ++changed;
                        printf( "\t\tchaning population to %d\n", population );
                        memmove( &PlanetBuffer[ 58 ], &population, sizeof( int ) );
                    }
                    if( PlanetBuffer[ 94 ] < 5 ) {
                        PlanetBuffer[ 94 ] = 5;
                        ++changed;
                        printf( "\t\tadding 5 bases\n" );
                    }
                    switch( PlanetBuffer[ 40 ] ) {
                            case 0: /* ultra poors become ultra rich */
                            case 2: /* normals become ultra rich */
                                 PlanetBuffer[ 40 ] = 5;
                                 ++changed;
                                 printf( "\t\ttransformed to ultra rich\n" );
                                 break;
                            case 1: /* poors become artifacts */
                            case 4: /* riches become artifacts */
                                 PlanetBuffer[ 40 ] = 3;
                                 ++changed;
                                 printf( "\t\ttransformed to artifacts\n" );
                                 break;
                    }
                }
                if( changed ) {
                    lseek( hSaveFile, Floc, SEEK_SET );
                    WriteResult = write( hSaveFile, PlanetBuffer, 184 );
                }
                Floc = tell( hSaveFile );
                ReadResult = read( hSaveFile, PlanetBuffer, 184 );
          }
          lseek( hSaveFile, 29716L, SEEK_SET );
          read( hSaveFile, &resources, sizeof( unsigned long ) );
          if( resources < 5000000L ) {
                printf( "\nboosting resources...\n" );
                resources = 5000000L;
                lseek( hSaveFile, 29716L, SEEK_SET );
                write( hSaveFile, &resources, sizeof( unsigned long ) );
         }
         close( hSaveFile );
     } else {
         printf( "Cannot find %s\n", argv[ 1 ] );
     }
     return( 0 );
}

